using System;
using System.IO;
using System.Data;
using System.Web;
using System.Xml;

	/*
	Created by: Kristofer Gafvert
	Published at: http://www.it-notebook.org/iis/article/change_domain_redirect_custom_404.htm
	Purpose: Use a custom 404 to redirect to another page, it the missing page can be mapped to a new page.
	
	Free to use, but not publish in its entire to other website.
	
	*/
	public partial class Error : System.Web.UI.Page
	{
		protected void Page_Load(object sender, System.EventArgs e)
		{
			String queryString = Request.Url.Query.ToString();
			String[] queryStringSplit = queryString.Split(new Char[] {';'});
			
			String failingUrl = queryStringSplit[1];
			
			TextReader textFile = new StreamReader(Server.MapPath("urlmap.txt"));
			
			String lookupString = "";
			String oldUrl = "";
			String newUrl = "";
			
			while ((lookupString = textFile.ReadLine()) != null)
			{				
				oldUrl = lookupString.Split(new Char[] {';'})[0];
				newUrl = lookupString.Split(new Char[] {';'})[1];
				
				if (oldUrl.ToLower() == failingUrl.ToLower())
				{
					break;
				}				
			}
			textFile.Close();
			if(oldUrl.ToLower() == failingUrl.ToLower())
			{
				//It's a 301
				form1.InnerHtml = "<h1>Object Moved</h1> This document may be found <a href=\"" + newUrl + "\">here</a>";
				Page.Header.Title = "Document Moved";
				Response.Status = "301 Moved Permanently";
				Response.AddHeader("Location", newUrl);
			}
			else
			{
				//It's a 404
				String body = @"<h1>The page cannot be found</h1>
								Ooops, the page you are looking for is not available.";
				form1.InnerHtml = body;
				Page.Header.Title = "The page cannot be found";
				Response.Status = "404 Not Found";
			}
		}
	}


